(ns remcon.core
  (:gen-class))

(require '[etaoin.api :as e]
         '[etaoin.keys :as k]
         '[clojure.string :as str])

(defn make-general [addr]
  {:address addr
   ;:vid {:class "yayin-alani"}
   :vid {:class "media"}
   :autostarts true
   :muted true})

(def channels {
               "trt-muzik" (make-general "https://tv.canlitv.ing/trtmuzikcanli")
               "tv8" {:address "https://www.tv8.com.tr/canli-yayin"
                      :vid {:id "AcunnPlayerContainer"}
                      :muted true
                      :autostarts true}
               "show" (make-general "https://tv.canlitv.ing/show-tv-canli")
               "star" (make-general "https://tv.canlitv.ing/startvcanli")
               "kanald" {:address "https://www.kanald.com.tr/canli-yayin"
                         :vid {:id "playerArea"}
                         :muted true
                         :autostarts true}
               "atv" {:address "https://www.atv.com.tr/canli-yayin"
                      :vid {:id "live"}
                      :muted true
                      :autostarts false}
               "cn" (make-general "https://tv.canlitv.ing/cartoon-network")
               "trt1" {:address "https://www.tabii.com/tr/watch/live/trt1"
                       :vid {:class "_Ehgxv"}
                       :muted false
                       :autostarts true}
               })

(defn toggle-fs [driver ch]
  (e/double-click driver (:vid ch)))


(defmacro unless [pred & body]
  `(if (not ~pred)
     (do ~@body)))

(defn general-goto [driver ch]
  (e/go driver (:address ch))
  (e/wait-visible driver (:vid ch))
  (e/wait driver 2)
  (unless (:autostarts ch)
          (e/click driver (:vid ch))
          ;(e/wait driver 3)
          )
  (when (:muted ch)
    (if (not (:autostarts ch))
      (do
        (e/fill-active driver "m")
        (println "hi1231232131"))
      (do
        (e/click driver (:vid ch))
        (e/wait driver 0.1)
        (e/click driver (:vid ch))
        (e/fill-active driver "m")))))

(defn easy [d chname]
  (general-goto d (get channels chname) )
  (toggle-fs d (get channels chname)))

(defn -main
  "I don't do a whole lot ... yet."
  [& args]
  (let [driver (if (= (first args) "ch")
                 (e/chrome {:args ["start-maximized" "--no-sandbox" "--disable-dev-shm-usage"]})
                 (e/firefox))]
    (loop [line (read-line)
           channel nil]
      (cond
        (= line "exit") (e/quit driver)
        (= line "fst") (do
                         (if (not (nil? channel))
                           (toggle-fs driver channel)
                           (println "No channel is open right now."))
                         (recur (read-line) channel))
        (= line "refresh") (do
                             (e/refresh driver)
                             (toggle-fs driver channel)
                             (recur (read-line) channel)) 
        (get channels line) (do
                              (general-goto driver (get channels line))
                              (toggle-fs driver (get channels line))
                              (recur (read-line) (get channels line)))
        :else (do (println "Don't know that command.")
                  (recur (read-line) channel))))))